﻿// Copyright (c) .NET Foundation. All rights reserved.
// Licensed under the Apache License, Version 2.0. See License.txt in the project root for license information.

namespace Microsoft.EntityFrameworkCore.Cosmos.Storage.Internal
{
    /// <summary>
    ///     This is an internal API that supports the Entity Framework Core infrastructure and not subject to
    ///     the same compatibility standards as public APIs. It may be changed or removed without notice in
    ///     any release. You should only use it directly in your code with extreme caution and knowing that
    ///     doing so can result in application failures when updating to a new Entity Framework Core release.
    /// </summary>
    public enum CosmosConcurrencyMode
    {
        /// <summary>
        /// No concurrency check.
        /// </summary>
        None = 0,

        /// <summary>
        /// Accept if token matches current value.
        /// </summary>
        IfMatch,

        /// <summary>
        /// Accept if token does not match current value.
        /// </summary>
        IfNoneMatch = 2,
    }
}
